## reposurgeon 3.29

=== Makefile ===
#
# makefile for reposurgeon
#

INSTALL=install
XMLTO=xmlto
ASCIIDOC=asciidoc
prefix?=/usr/local
mandir?=share/man
target=$(DESTDIR)$(prefix)

CYTHON?=cython
PYVERSION=2.7
pyinclude?=$(shell pkg-config --cflags python-$(PYVERSION) || echo "-I/usr/include/python$(PYVERSION)")
pylib?=$(shell pkg-config --libs python-$(PYVERSION) || echo "-lpython$(PYVERSION)")

VERS=$(shell sed <reposurgeon -n -e '/version=\(.*\)/s//\1/p')

SOURCES = README.md NEWS AUTHORS COPYING TODO
SOURCES += \
	reposurgeon reposurgeon.xml \
	repotool repotool.xml \
	repodiffer repodiffer.xml \
	repomapper repomapper.xml \
	reporting-bugs.asc features.asc dvcs-migration-guide.asc \
	reposurgeon-mode.el
SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases

.PHONY: all install install-cyreposurgeon clean version pylint check zip release refresh
.INTERMEDIATE: cyreposurgeon.c cyrepodiffer.c
.PRECIOUS: cyreposurgeon.o cyrepodiffer.o

all: reposurgeon.1 repotool.1 repodiffer.1 repomapper.1 \
     reposurgeon.html repotool.html repodiffer.html repomapper.html \
     dvcs-migration-guide.html features.html reporting-bugs.html

%.1: %.xml
	$(XMLTO) man $<

%.html: %.xml
	$(XMLTO) html-nochunks $<

dvcs-migration-guide.html: ASCIIDOC_ARGS=-a toc
%.html: %.asc
	$(ASCIIDOC) $(ASCIIDOC_ARGS) $<

cy%.c: %
	$(CYTHON) --embed $< -o $@

cy%.o: cy%.c
	${CC} ${CFLAGS} $(pyinclude) -c $< -o $@

cy%: cy%.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ $(pylib) -o $@

install: all
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
	$(INSTALL) -d "$(target)/$(mandir)/man1"
	$(INSTALL) -m 755 reposurgeon repotool repodiffer "$(target)/bin"
	$(INSTALL) -m 644 README.md NEWS TODO reposurgeon-git-aliases *.html \
		"$(target)/share/doc/reposurgeon"
	$(INSTALL) -m 644 *.1 "$(target)/$(mandir)/man1"

install-cyreposurgeon: cyreposurgeon
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -m 755 cyreposurgeon "$(target)/bin"

clean:
	rm -fr  *~ *.1 *.html *.tar.xz MANIFEST *.md5
	rm -fr .rs .rs* test/.rs test/.rs*
	rm -f typescript test/typescript *.pyc
	rm -f cyreposurgeon.c cyreposurgeon.o cyreposurgeon

reposurgeon-$(VERS).tar.xz: $(SOURCES)
	@ls $(SOURCES) | sed s:^:reposurgeon-$(VERS)/: >MANIFEST
	@(cd ..; ln -s reposurgeon reposurgeon-$(VERS))
	(cd ..; tar -cJf reposurgeon/reposurgeon-$(VERS).tar.xz `cat reposurgeon/MANIFEST`)
	@(cd ..; rm reposurgeon-$(VERS))

version:
	@echo $(VERS)

COMMON_PYLINT = --rcfile=/dev/null --reports=n \
	--msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
	--dummy-variables-rgx='^_'
PYLINTOPTS1 = "C0103,C0111,C0301,C0302,C0322,C0324,C0325,C0321,C0323,C0330,C1001,R0201,R0902,R0903,R0904,R0911,R0912,R0913,R0914,R0915,W0108,W0110,W0123,W0141,W0142,W0212,W0233,W0603,W0632,W0640,W0511,W0611,E1101,E1103,E1124,I0011,F0401"
PYLINTOPTS2 = "C0103,C0111,C0301,C0326,C0330,C1001,W0603,W0621,E1101,E1103,R0902,R0903,R0912,R0914,R0915"
PYLINTOPTS3 = "C0103,C0301,C1001,R0903,W0621"
pylint:
	@pylint $(COMMON_PYLINT) --disable=$(PYLINTOPTS1) reposurgeon
	@pylint $(COMMON_PYLINT) --disable=$(PYLINTOPTS2) repodiffer
	@pylint $(COMMON_PYLINT) --disable=$(PYLINTOPTS3) repomapper

check:
	cd test; $(MAKE) --quiet

dist: reposurgeon-$(VERS).tar.xz reposurgeon.1 repotool.1 repodiffer.1

reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5

zip: $(SOURCES)
	zip -r reposurgeon-$(VERS).zip $(SOURCES)

release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repodiffer.html reporting-bugs.html dvcs-migration-guide.html features.html
	shipper version=$(VERS) | sh -e -x

refresh: reposurgeon.html repodiffer.html reporting-bugs.html features.html
	shipper -N -w version=$(VERS) | sh -e -x

=== debian/changelog ===
reposurgeon (3.29-1) unstable; urgency=medium

  * Initial release (Closes: #702485)

 -- Anthony Fok <foka@debian.org>  Fri, 25 Sep 2015 12:07:58 -0600

reposurgeon (3.18-1) UNRELEASED; urgency=low

  * First attempt at Initial release, rejected due to inconsistent
    license in revdir.c (GPL-2) vs the rest (GPL-2+) of the
    cvs-fast-export package, which reposurgeon recommends.
    (would have closed #702485)
  * Cherry-pick minor post-3.18 fixes from upstream.

 -- Anthony Fok <foka@debian.org>  Sat, 20 Dec 2014 13:21:08 -0700

=== debian/control ===
Source: reposurgeon
Section: vcs
Priority: optional
Maintainer: Anthony Fok <foka@debian.org>
Build-Depends: debhelper (>= 9), dh-python, python (>= 2.7.2-7), xmlto, asciidoc
X-Python-Version: >= 2.7.2
Standards-Version: 3.9.6
Homepage: http://www.catb.org/esr/reposurgeon/
Vcs-Git: git://anonscm.debian.org/collab-maint/reposurgeon.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/reposurgeon.git

Package: reposurgeon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Recommends: git, cvs-fast-export
Suggests: bzr-fastimport, hg-fast-export, svn, darcs, fossil
Description: Tool for editing version-control repository history
 reposurgeon enables risky operations that version-control systems don't want 
 to let you do, such as editing past comments and metadata and removing
 commits.  It works with any version control system that can export and 
 import git fast-import streams, including git, hg, fossil, bzr, CVS, and RCS. 
 It can also read Subversion dump files directly and can thus be used to script
 production of very high-quality conversions from Subversion to any 
 supported DVCS.
 .
 repodiffer is a program that reports differences between repository 
 histories. It uses a diff(1)-like algorithm to identify spans of
 identical revisions, and to pick out revisions that have been 
 changed or deleted or inserted. It may be useful for comparing the
 output of different repository-conversion tools in detail.
 .
 Another auxiliary program, repopuller, assists in mirroring Subversion
 repositories.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with python2

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

=== debian/watch ===
version=3
http://www.catb.org/~esr/reposurgeon/reposurgeon-(\d[\d.]*)\.tar\.(?:gz|bz2|xz)

## reposurgeon 3.37

=== Makefile ===
#
# makefile for reposurgeon
#

INSTALL=install
XMLTO=xmlto
ASCIIDOC=asciidoc
PYLINT=pylint
prefix?=/usr/local
mandir?=share/man
target=$(DESTDIR)$(prefix)

CYTHON?=cython
PYVERSION=2.7
pyinclude?=$(shell pkg-config --cflags python-$(PYVERSION) || echo "-I/usr/include/python$(PYVERSION)")
pylib?=$(shell pkg-config --libs python-$(PYVERSION) || echo "-lpython$(PYVERSION)")

VERS=$(shell sed <reposurgeon -n -e '/version=\(.*\)/s//\1/p')

SOURCES = README.md NEWS AUTHORS COPYING TODO
SOURCES += \
	reposurgeon reposurgeon.xml \
	repotool repotool.xml \
	repodiffer repodiffer.xml \
	repomapper repomapper.xml \
	repocutter repocutter.xml \
	reporting-bugs.asc features.asc dvcs-migration-guide.asc \
	reposurgeon-mode.el
SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
SOURCES += Dockerfile ci/prepare.sh ci/Makefile ci/requirements.txt

.PHONY: all install install-cyreposurgeon clean version pylint check zip release refresh \
    docker-build docker-check docker-check-noscm
.INTERMEDIATE: cyreposurgeon.c cyrepodiffer.c
.PRECIOUS: cyreposurgeon.o cyrepodiffer.o

MANPAGES = reposurgeon.1 repotool.1 repodiffer.1 repomapper.1 repocutter.1
all:  $(MANPAGES) $(MANPAGES:.1=.html) \
     dvcs-migration-guide.html features.html reporting-bugs.html

%.1: %.xml
	$(XMLTO) man $<

%.html: %.xml
	$(XMLTO) html-nochunks $<

dvcs-migration-guide.html: ASCIIDOC_ARGS=-a toc
%.html: %.asc
	$(ASCIIDOC) $(ASCIIDOC_ARGS) $<

cy%.c: %
	$(CYTHON) --embed $< -o $@

cy%.o: cy%.c
	${CC} ${CFLAGS} $(pyinclude) -c $< -o $@

cy%: cy%.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ $(pylib) -o $@

#
# Installation
#

install: all
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
	$(INSTALL) -d "$(target)/$(mandir)/man1"
	$(INSTALL) -m 755 reposurgeon repomapper repotool repodiffer repocutter "$(target)/bin"
	$(INSTALL) -m 644 README.md NEWS TODO reposurgeon-git-aliases *.html \
		"$(target)/share/doc/reposurgeon"
	$(INSTALL) -m 644 *.1 "$(target)/$(mandir)/man1"

install-cyreposurgeon: cyreposurgeon
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -m 755 cyreposurgeon "$(target)/bin"

clean:
	rm -fr  *~ *.1 *.html *.tar.xz MANIFEST *.md5
	rm -fr .rs .rs* test/.rs test/.rs*
	rm -f typescript test/typescript *.pyc
	rm -f cyreposurgeon.c cyreposurgeon.o cyreposurgeon

version:
	@echo $(VERS)

#
# Code validation
#

COMMON_PYLINT = --rcfile=/dev/null --reports=n \
	--msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
	--dummy-variables-rgx='^_'
PYLINTOPTS1 = "C0103,C0111,C0301,C0302,C0322,C0324,C0325,C0321,C0323,C0330,C0410,C1001,R0201,R0101,R0204,R0902,R0903,R0904,R0911,R0912,R0913,R0914,R0915,W0108,W0110,W0123,W0122,W0141,W0142,W0212,W0221,W0232,W0233,W0603,W0632,W0640,W0511,W0611,E0611,E1101,E1103,E1124,I0011,F0401"
PYLINTOPTS2 = "C0103,C0111,C0325,C0301,C0326,C0330,C0410,C1001,W0603,W0621,E1101,E1103,R0401,R0902,R0903,R0912,R0914,R0915"
PYLINTOPTS3 = "C0103,C0301,C0410,C1001,R0401,R0903,W0621"
PYLINTOPTS4 = "C0103,C0301,C0325,C0111,C0410,C0413,C1001,R0101,R0903,R0401,R0912,R0913,R0914,R0915,W0110,W0141,W0621,W1504"
pylint:
	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS1) reposurgeon
	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS2) repodiffer
	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS3) repomapper
	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS4) repocutter

check:
	cd test; $(MAKE) --quiet

#
# Continuous integration.  More specifics are in the ci/ directory
#

docker-build: $(SOURCES)
	docker build -t reposurgeon .

docker-check: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon make check

docker-check-only-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-only-$(*) && make check"

docker-check-no-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-no-$(*) && make check"

# Test that support for each VCS stands on its own and test without legacy
# VCS installed
docker-check-noscm: docker-check-only-bzr docker-check-only-cvs \
    docker-check-only-git docker-check-only-mercurial \
    docker-check-only-subversion docker-check-no-cvs 
# Due to many tests depending on git, docker-check-only-mercurial is a very poor
# test of Mercurial

#
# Release shipping.
#

reposurgeon-$(VERS).tar.xz: $(SOURCES)
	@ls $(SOURCES) | sed s:^:reposurgeon-$(VERS)/: >MANIFEST
	@(cd ..; ln -s reposurgeon reposurgeon-$(VERS))
	(cd ..; tar -cJf reposurgeon/reposurgeon-$(VERS).tar.xz `cat reposurgeon/MANIFEST`)
	@(cd ..; rm reposurgeon-$(VERS))

dist: reposurgeon-$(VERS).tar.xz reposurgeon.1 repotool.1 repodiffer.1

reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5

zip: $(SOURCES)
	zip -r reposurgeon-$(VERS).zip $(SOURCES)

release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repodiffer.html repocutter.html reporting-bugs.html dvcs-migration-guide.html features.html
	shipper version=$(VERS) | sh -e -x

refresh: reposurgeon.html repodiffer.html reporting-bugs.html features.html
	shipper -N -w version=$(VERS) | sh -e -x

=== debian/changelog ===
reposurgeon (3.37-1) unstable; urgency=medium

  * New upstream version
  * Change license from BSD-3-Clause to BSD-2-Clause as upstream has done
  * Bump Standards-Version to 3.9.8 (no change)
  * Use secure https URLs for Vcs-* fields
  * Update dependency on Python 2 to Python 3
  * Update package description listing renamed executables correctly.
    Thanks to Alberto Luaces for the heads up. (Closes: #822979)

 -- Anthony Fok <foka@debian.org>  Sun, 01 May 2016 02:21:32 +0800

=== debian/control ===
Source: reposurgeon
Section: vcs
Priority: optional
Maintainer: Anthony Fok <foka@debian.org>
Build-Depends: debhelper (>= 9), dh-python, python3, xmlto, asciidoc
Standards-Version: 3.9.8
Homepage: http://www.catb.org/esr/reposurgeon/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/reposurgeon.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/reposurgeon.git

Package: reposurgeon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Recommends: git, cvs-fast-export
Suggests: bzr-fastimport, hg-fast-export, svn, darcs, fossil
Description: Tool for editing version-control repository history
 `reposurgeon` enables risky operations that version-control systems
 don't want to let you do, such as (a) editing past comments and metadata,
 (b) excising commits, (c) coalescing commits, and (d) removing files and
 subtrees from repo history. The original motivation for `reposurgeon`
 was to clean up artifacts created by repository conversions.
 .
 `reposurgeon` is also useful for scripting very high-quality conversions
 from Subversion.  It is better than `git-svn` at tag lifting,
 automatically cleaning up `cvs2svn` conversion artifacts, dealing with
 nonstandard repository layouts, recognizing branch merges, handling
 mixed-branch commits, and generally at coping with Subversion's many
 odd corner cases.  Normally Subversion repos should be analyzed at a
 rate of upwards of ten thousand commits per minute.
 .
 `repodiffer` is a program that reports differences between repository
 histories. It uses a `diff(1)`-like algorithm to identify spans of
 identical revisions, and to pick out revisions that have been
 changed or deleted or inserted. It may be useful for comparing the
 output of different repository-conversion tools in detail.
 .
 Another auxiliary program, `repotool`, performs various useful
 operations such as checkouts and tag listing in a VCS-independent
 manner.  Yet another, `repomapper`, assists in automatically preparing
 contributor maps of CVS and SVN repositories.
 .
 The `repocutter` program is available for some specialized operations on
 Subversion dumpfiles; it may be useful in extracting portions of
 particularly gnarly Subversion repositories for conversion witth
 reposurgeon.
 .
 This distribution supports a generic conversion workflow using these
 tools, and includes the DVCS Migration Guide that describes how to use it.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --with python2
+	dh $@ --with python3
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr

## reposurgeon 3.42

=== ci/requirements.txt ===
mercurial
pylint>=1.2,<1.5
astroid>=1.3.3,<1.4

=== test/Makefile ===
# Test-suite makefile for reposurgeon

# By setting the REPOSURGEON environment variable and using -e
# a different implementation can be plugged in to the tests.

# Use absolute path so tests that change working directory still use 
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PATH := $(realpath ..):$(realpath .):${PATH}
REPOSURGEON := reposurgeon 

# Defeat annoying behavior under Mac OS X - builtin echo doesn't do -n
ECHO := /bin/echo

# Without this, under CentOS Python may emit invisible ANSI strings
# that confuse diff
TERM := dumb

default:
	@(cd ..; make -e --quiet pylint)
	@$(REPOSURGEON) "runtests"
	@setpython python2
	@make -e --quiet all
	@setpython python3
	@make -e --quiet all
	@setpython python

all: listcheck roundtrip roundtrip-compress mailboxing fi-regress coalesce \
		git-regress git-regress-branches git-regress-merges git-regress-tags \
		hg-regress hg-regress-branches hg-regress-merges hg-regress-tags hg-regress-patho \
		svnload-regress legacy-regress svndump-regress \
		repodiffer-regress repomapper-regress \
		repotool-regress repocutter-regress
	@echo "=== No diff output is good news."

.SUFFIXES: .svn .chk .fi .map

.svn.chk:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@ 2>&1
.svn.fi:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@
.svn.map:
	$(REPOSURGEON) "read <$<" "legacy write -" >$@

buildregress: fi-buildregress svnload-buildregress legacy-buildregress \
	svndump-buildregress repodiffer-buildregress repomapper-buildregress \
	repocutter-buildregress hg-buildregress-branches hg-buildregress-patho

clean:
	rm -fr .rs* test-repo test-checkout git-repo left-repo right-repo *~

# Show summary lines for all tests.
testlist:
	@grep --text '^##' *.tst
	@grep --text '^ ##' *.svn
listcheck:
	@for f in *.tst *.svn; do \
	    if ( head -3 $$f | grep --text -q '^ *##' ); then :; else echo "$$f needs a description"; fi; \
	done

# Test that all stream files round-trip properly
roundtrip:
	@echo "=== Testing stream-file round-tripping:" 
	@for file in *.fi; do \
	    echo "  $${file}"; \
	    $(REPOSURGEON) "read -;write -" <$$file >/tmp/rs$$$$ || exit 1; \
	    [ -s /tmp/rs$$$$ ] && diff --text -u $${file} /tmp/rs$$$$ \
		|| exit 1; \
	    rm -f /tmp/rs$$$$ || exit 1; \
	done

# Test that all stream files round-trip properly with compression
roundtrip-compress:
	@echo "=== Testing stream-file round-tripping with compression:" 
	@for file in *.fi; do \
	    echo "  $${file}"; \
	    $(REPOSURGEON) "set compressblobs" "read -;write -" \
		<$$file >/tmp/rs$$$$ || exit 1; \
	    [ -s /tmp/rs$$$$ ] && diff --text -u $${file} /tmp/rs$$$$ \
		|| exit 1; \
	    rm -f /tmp/rs$$$$ || exit 1; \
	done

# Test that dumping metadata to mailbox form and updating from the mailbox
# is idempotent if you make no changes to the mailbox.
mailboxing:
	@echo "=== Testing mailbox-out/mailbox-in roundtripping:"
	@for file in *.fi; do \
	    echo "  $${file}";\
	    $(REPOSURGEON) "read <$${file}" "edit echo>/dev/null" "write -" \
		>/tmp/regress$$$$ || exit 1; \
	    [ -s /tmp/regress$$$$ ] && diff --text -u $${file} /tmp/regress$$$$ \
		|| exit 1; \
	done
	@rm -f /tmp/regress$$$$

# General regression testing of commands and output; look at the *.tst and
# corresponding *.chk files to see which tests this runs.
TESTLOADS := $(shell ls -1 *.tst | sed '/.tst/s///')
fi-buildregress:
	@for file in $(TESTLOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(REPOSURGEON) "script $${file}.tst testing123" >$${file}.chk \
		2>&1 || exit 1; \
	done
fi-regress:
	@echo "=== Running general tests:"
	@for file in $(TESTLOADS); do \
	    $(ECHO) -n "  $${file} "; grep --text '##' $${file}.tst  || echo ' ## (no description)'; \
	    if $(REPOSURGEON) "script $${file}.tst testing123" >/tmp/regress$$$$ 2>&1; \
	    then diff --text -u $${file}.chk /tmp/regress$$$$ || exit 1; \
	    else echo "*** Nonzero return status on $${file}!"; exit 1; fi \
	done
	@rm -f /tmp/regress$$$$

# Test coalescence operation.
COALESCE=uncoalesced
buildcoalesce:
	@for file in $(COALESCE); do \
	    echo "Rebuilding coalescence regression test using $${file}.fi"; \
	    $(REPOSURGEON) "read <$${file}.fi; coalesce; write -" \
		>$${file}.chk || exit 1; \
	done
	@rm -f /tmp/regress$$$$
coalesce:
	@echo "=== Coalescence regression test:"
	@for file in $(COALESCE); do \
	    echo "  $${file}.fi"; \
	    $(REPOSURGEON) "read <$${file}.fi; coalesce; write -" \
		>/tmp/regress$$$$ || exit 1; \
	    [ -s /tmp/regress$$$$ ] && diff --text -u $${file}.chk /tmp/regress$$$$ \
		|| exit 1; \
	done
	@rm -f /tmp/regress$$$$

# Test the git extractor
GITLOADS = bs
git-regress:
	@echo "=== Testing git-extractor:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITLOADS); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the git extractor with multiple git branches
GITBRANCHES = be bb
git-regress-branches:
	@echo "=== Testing git-extractor with multiple git branches:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITBRANCHES); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the git extractor with merges
GITMERGES = be2 be3 be4 be5 be6
git-regress-merges:
	@echo "=== Testing git-extractor with merges:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITMERGES); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the git extractor with tags
GITTAGS = bt bt2
git-regress-tags:
	@echo "=== Testing git-extractor with tags:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(GITTAGS); do \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor
HGLOADS = testrepo2
hg-regress:
	@echo "=== Testing hg-extractor:"
	@if command -v hg >/dev/null 2>&1 && command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(HGLOADS); do \
		if (echo "  $${test}.fi" >&2; \
		./hg-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg or git missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with multiple hg branches
# NOTE: the bb-alt test demonstrates an hg repo with coloring that git cannot reproduce
HGBRANCHES = be be2 be3 bb-alt be-bookmarks
hg-buildregress-branches:
	@for file in $(HGBRANCHES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-branches:
	@echo "=== Testing hg-extractor with multiple hg branches:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGBRANCHES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with merges
HGMERGES = be2 be3 be4 be5 be6
hg-buildregress-merges:
	@for file in $(HGMERGES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-merges:
	@echo "=== Testing hg-extractor with merges:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGMERGES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with tags
HGTAGS = bt bt2
hg-buildregress-tags:
	@for file in $(HGTAGS); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-tags:
	@echo "=== Testing hg-extractor with tags:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGTAGS); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test the hg extractor with pathological loads
HGPATHO = be-subrepo be-subrepo2
hg-buildregress-patho:
	@for file in $(HGPATHO); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit 1; \
	done
hg-regress-patho:
	@echo "=== Testing hg-extractor with pathological loads:"
	@if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGPATHO); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi
	@rm -f /tmp/regress$$$$

# Test loading from Subversion
SVNLOADS := $(shell ls *.svn | sed '/.svn/s///')
svnload-buildregress:
	@for test in $(SVNLOADS); do \
	    if [ ! -f $${test}.tst ] ; \
	    then \
		    echo "Remaking $${test}.chk"; \
		    rm -f $${test}.chk && make --quiet $${test}.chk \
			|| exit 1; \
	    fi \
	done
svnload-regress:
	@echo "== Testing loading of Subversion streams:"
	@for test in $(SVNLOADS); \
	do \
	    if [ ! -f $${test}.tst ] ; \
	    then \
		(if { $(ECHO) -n "  $${test}.svn"; grep --text '^ ##' $${test}.svn || echo ' ## (no description)'; } >&2; \
		$(REPOSURGEON) "read <$${test}.svn" "prefer git" "write -" >/tmp/regress$$$$ 2>&1; \
		then diff --text -u $${test}.chk /tmp/regress$$$$ || exit 1; \
		else echo "*** Nonzero return status on $${test}!"; exit 1; fi; \
		if command -v git >/dev/null 2>&1 ; \
		then \
		    mkdir /tmp/reposurgeon$$$$ || exit 1; \
		    (cd /tmp/reposurgeon$$$$ || exit 1; \
			git init --quiet || exit 1; \
			grep --text -v 'reposurgeon:' /tmp/regress$$$$ | git fast-import --quiet) \
			    || exit 1; \
		    rm -fr /tmp/reposurgeon$$$$\
		else echo "    Skipped, git missing."; \
		fi \
		) || exit 1; \
	    fi \
	done
	@rm -f /tmp/regress$$$$

REFLOADS=references mergeinfo-with-split
legacy-buildregress:
	@for test in $(REFLOADS); \
	do \
	    echo "Remaking $${test}.map"; \

=== debian/changelog ===
reposurgeon (3.42-2ubuntu1) artful; urgency=medium

  * Non-maintainer upload.
  * debian/patches/pylint-fixes.patch: fixes for new python linting
    warnings.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 27 Aug 2017 07:41:13 +0000

reposurgeon (3.42-2) unstable; urgency=medium

  * Skip building cyreposurgeon on mips, mipsel and sh4.
    This is to prevent build machines for these architectures
    from running out of memory during the cython/cc1 run.
  * Skip building cyreposurgeon on hurd-i386 too
    to see if it fixes the failed test later on.
  * Ignore git build-dependency on alpha/ppc64/sparc64/x32 temporarily.
    For some reasons, git (1:2.13.3-1) from July 2017 fails to build
    on these architectures, causing BD-Uninstallable for reposurgeon.
    Fortunately, reposurgeon skips git-related tests gracefully
    when git is not installed.

 -- Anthony Fok <foka@debian.org>  Fri, 04 Aug 2017 20:49:28 -0600

reposurgeon (3.42-1) unstable; urgency=medium

  * New upstream release
  * Use debhelper (>= 10)
  * Bump Standards-Version to 4.0.0:
    Use https form of the copyright-format URL in debian/copyright
  * Revert from Python 3 to Python 2 to pass all tests
  * Build cyreposurgeon too with cython
  * Add "Build-Depends: cvs, git, mercurial, subversion" for tests

 -- Anthony Fok <foka@debian.org>  Fri, 04 Aug 2017 12:08:16 -0600

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,20 @@
 Source: reposurgeon
 Section: vcs
 Priority: optional
-Maintainer: Anthony Fok <foka@debian.org>
-Build-Depends: debhelper (>= 9), dh-python, python3, xmlto, asciidoc
-Standards-Version: 3.9.8
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
+Build-Depends: debhelper (>= 10), dh-python,
+               python, cython, libpython-dev, pkg-config, pylint,
+               xmlto, asciidoc-base,
+               cvs, git [!alpha !ppc64 !sparc64 !x32], mercurial, subversion
+Standards-Version: 4.0.0
 Homepage: http://www.catb.org/esr/reposurgeon/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/reposurgeon.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/reposurgeon.git
 
 Package: reposurgeon
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
 Recommends: git, cvs-fast-export
 Suggests: bzr-fastimport, hg-fast-export, svn, darcs, fossil
 Description: Tool for editing version-control repository history

=== debian/rules ===
--- 
+++ 
@@ -14,8 +14,22 @@
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+
 %:
-	dh $@ --with python3
+	dh $@ --with python2
+
+ifeq ($(filter mips mipsel hurd-i386 sh4,$(DEB_BUILD_ARCH)),)
+override_dh_auto_build:
+	dh_auto_build -- all cyreposurgeon
 
 override_dh_auto_install:
+	dh_auto_install -- prefix=/usr install-cyreposurgeon
+else
+override_dh_auto_install:
 	dh_auto_install -- prefix=/usr
+endif
+
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f test/python

## reposurgeon 3.44

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 INSTALL=install
 XMLTO=xmlto
+XMLTOOPTS=-m docbook-extra.xml
 ASCIIDOC=asciidoc
 PYLINT=pylint
 prefix?=/usr/local
@@ -15,9 +16,8 @@
 pyinclude?=$(shell pkg-config --cflags python-$(PYVERSION) || echo "-I/usr/include/python$(PYVERSION)")
 pylib?=$(shell pkg-config --libs python-$(PYVERSION) || echo "-lpython$(PYVERSION)")
 
-VERS=$(shell sed <reposurgeon -n -e '/version=\(.*\)/s//\1/p')
-
-SOURCES = README.md NEWS AUTHORS COPYING TODO
+VERS=$(shell sed <reposurgeon -n -e '/version=\"\(.*\)\"/s//\1/p')
+SOURCES += docbook-extra.xml nofooter.conf
 SOURCES += \
 	reposurgeon reposurgeon.xml \
 	repotool repotool.xml \
@@ -29,22 +29,24 @@
 SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
 SOURCES += Dockerfile ci/prepare.sh ci/Makefile ci/requirements.txt
 
-.PHONY: all install install-cyreposurgeon clean version pylint check zip release refresh \
+.PHONY: all install clean uninstall version pylint check zip release refresh \
     docker-build docker-check docker-check-noscm
-.INTERMEDIATE: cyreposurgeon.c cyrepodiffer.c
-.PRECIOUS: cyreposurgeon.o cyrepodiffer.o
 
+BINARIES = reposurgeon repotool repodiffer repomapper repocutter
 MANPAGES = reposurgeon.1 repotool.1 repodiffer.1 repomapper.1 repocutter.1
-all:  $(MANPAGES) $(MANPAGES:.1=.html) \
-     dvcs-migration-guide.html features.html reporting-bugs.html
+HTMLFILES = $(MANPAGES:.1=.html) \
+            dvcs-migration-guide.html features.html reporting-bugs.html
+SHARED    = README.md NEWS TODO reposurgeon-git-aliases $(HTMLFILES)
+
+all:  $(MANPAGES) $(HTMLFILES)
 
 %.1: %.xml
-	$(XMLTO) man $<
+	$(XMLTO) $(XMLTOOPTS) man $<
 
 %.html: %.xml
-	$(XMLTO) html-nochunks $<
+	$(XMLTO) $(XMLTOOPTS) html-nochunks $<
 
-dvcs-migration-guide.html: ASCIIDOC_ARGS=-a toc
+dvcs-migration-guide.html: ASCIIDOC_ARGS=-a toc -f nofooter.conf
 %.html: %.asc
 	$(ASCIIDOC) $(ASCIIDOC_ARGS) $<
 
@@ -65,20 +67,25 @@
 	$(INSTALL) -d "$(target)/bin"
 	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
 	$(INSTALL) -d "$(target)/$(mandir)/man1"
-	$(INSTALL) -m 755 reposurgeon repomapper repotool repodiffer repocutter "$(target)/bin"
-	$(INSTALL) -m 644 README.md NEWS TODO reposurgeon-git-aliases *.html \
-		"$(target)/share/doc/reposurgeon"
-	$(INSTALL) -m 644 *.1 "$(target)/$(mandir)/man1"
-
-install-cyreposurgeon: cyreposurgeon
-	$(INSTALL) -d "$(target)/bin"
-	$(INSTALL) -m 755 cyreposurgeon "$(target)/bin"
+	$(INSTALL) -m 755 $(BINARIES) "$(target)/bin"
+	$(INSTALL) -m 644 $(SHARED) "$(target)/share/doc/reposurgeon"
+	$(INSTALL) -m 644 $(MANPAGES) "$(target)/$(mandir)/man1"
 
 clean:
 	rm -fr  *~ *.1 *.html *.tar.xz MANIFEST *.md5
 	rm -fr .rs .rs* test/.rs test/.rs*
 	rm -f typescript test/typescript *.pyc
-	rm -f cyreposurgeon.c cyreposurgeon.o cyreposurgeon
+
+# Uninstallation
+INSTALLED_BINARIES := $(BINARIES:%="$(target)/bin/%")
+INSTALLED_SHARED   := $(SHARED:%="$(target)/share/doc/reposurgeon/%")
+INSTALLED_MANPAGES := $(MANPAGES:%="$(target)/$(mandir)/man1/%")
+
+uninstall:
+	rm -f $(INSTALLED_BINARIES)
+	rm -f $(INSTALLED_MANPAGES)
+	rm -f $(INSTALLED_SHARED)
+	rmdir "$(target)/share/doc/reposurgeon"
 
 version:
 	@echo $(VERS)
@@ -90,10 +97,10 @@
 COMMON_PYLINT = --rcfile=/dev/null --reports=n \
 	--msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
 	--dummy-variables-rgx='^_'
-PYLINTOPTS1 = "C0103,C0111,C0301,C0302,C0322,C0324,C0325,C0321,C0323,C0330,C0410,C1001,R0201,R0101,R0204,R0902,R0903,R0904,R0911,R0912,R0913,R0914,R0915,W0108,W0110,W0123,W0122,W0141,W0142,W0212,W0221,W0232,W0233,W0603,W0632,W0640,W0511,W0611,E0611,E1101,E1103,E1124,I0011,F0401"
-PYLINTOPTS2 = "C0103,C0111,C0325,C0301,C0326,C0330,C0410,C1001,W0603,W0621,E1101,E1103,R0401,R0902,R0903,R0912,R0914,R0915"
+PYLINTOPTS1 = "C0103,C0111,C0301,C0302,C0322,C0324,C0325,C0321,C0323,C0330,C0410,C0411,C0412,C0413,C1001,C1801,R0201,R0101,R0204,R0902,R0903,R0904,R0911,R0912,R0913,R0914,R0915,R1705,W0108,W0110,W0123,W0122,W0141,W0142,W0212,W0221,W0232,W0233,W0603,W0632,W0633,W0640,W0511,W0611,E0611,E1101,E1103,E1124,E1133,I0011,F0401"
+PYLINTOPTS2 = "C0103,C0111,C0325,C0301,C0326,C0330,C0410,C1001,W0603,W0621,E1101,E1103,R0401,R0902,R0903,R0912,R0914,R0915,R1705"
 PYLINTOPTS3 = "C0103,C0301,C0410,C1001,R0401,R0903,W0621"
-PYLINTOPTS4 = "C0103,C0301,C0325,C0111,C0410,C0413,C1001,R0101,R0903,R0401,R0912,R0913,R0914,R0915,W0110,W0141,W0621,W1504"
+PYLINTOPTS4 = "C0103,C0301,C0302,C0325,C0111,C0410,C0413,C1001,C1801,R0101,R0903,R0401,R0912,R0913,R0914,R0915,R1705,W0110,W0141,W0603,W0621,W1504"
 pylint:
 	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS1) reposurgeon
 	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS2) repodiffer
@@ -101,7 +108,10 @@
 	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS4) repocutter
 
 check:
-	cd test; $(MAKE) --quiet
+	cd test; $(MAKE) --quiet check
+
+portcheck:
+	cd test; $(MAKE) --quiet portcheck
 
 #
 # Continuous integration.  More specifics are in the ci/ directory
@@ -132,10 +142,7 @@
 #
 
 reposurgeon-$(VERS).tar.xz: $(SOURCES)
-	@ls $(SOURCES) | sed s:^:reposurgeon-$(VERS)/: >MANIFEST
-	@(cd ..; ln -s reposurgeon reposurgeon-$(VERS))
-	(cd ..; tar -cJf reposurgeon/reposurgeon-$(VERS).tar.xz `cat reposurgeon/MANIFEST`)
-	@(cd ..; rm reposurgeon-$(VERS))
+	tar --transform='s:^:reposurgeon-$(VERS)/:' --show-transformed-names -cJf reposurgeon-$(VERS).tar.xz $(SOURCES) test
 
 dist: reposurgeon-$(VERS).tar.xz reposurgeon.1 repotool.1 repodiffer.1

=== test/Makefile ===
--- 
+++ 
@@ -16,22 +16,30 @@
 # that confuse diff
 TERM := dumb
 
-default:
-	@(cd ..; make -e --quiet pylint)
+default: check
+
+# Speed check - test under the default in the hashbang line
+check:
+	@if command -v pylint >/dev/null 2>&1; then echo "=== Running pylint" && (cd ..; make -e --quiet pylint); else echo "pylint missing; skipping tests"; fi
+	@echo "=== Running built-in tests"
 	@$(REPOSURGEON) "runtests"
-	@setpython python2
-	@make -e --quiet all
-	@setpython python3
-	@make -e --quiet all
-	@setpython python
+	@if ./setpypy pypy; then time make -e --quiet all; else echo "pypy missing; skipping tests"; fi
+
+# Portability check - tests all dialects
+portcheck: check
+	@if ./setpypy python2; then time make -e --quiet all; else echo "python2 missing; skipping tests"; fi
+	@if ./setpypy python3; then time make -e --quiet all; else echo "python3 missing; skipping tests"; fi
+	@./setpypy pypy
 
 all: listcheck roundtrip roundtrip-compress mailboxing fi-regress coalesce \
 		git-regress git-regress-branches git-regress-merges git-regress-tags \
-		hg-regress hg-regress-branches hg-regress-merges hg-regress-tags hg-regress-patho \
-		svnload-regress legacy-regress svndump-regress \
+		hg-extractor svnload-regress liftcheck-regress legacy-regress svndump-regress \
 		repodiffer-regress repomapper-regress \
-		repotool-regress repocutter-regress
+		repotool-regress repocutter-regress svncheck-regress
 	@echo "=== No diff output is good news."
+
+hg-extractor: hg-regress hg-regress-branches hg-regress-merges \
+		hg-regress-tags hg-regress-patho
 
 .SUFFIXES: .svn .chk .fi .map
 
@@ -44,7 +52,8 @@
 
 buildregress: fi-buildregress svnload-buildregress legacy-buildregress \
 	svndump-buildregress repodiffer-buildregress repomapper-buildregress \
-	repocutter-buildregress hg-buildregress-branches hg-buildregress-patho
+	repotool-buildregress repocutter-buildregress hg-buildregress-branches \
+	hg-buildregress-patho svncheck-buildregress
 
 clean:
 	rm -fr .rs* test-repo test-checkout git-repo left-repo right-repo *~
@@ -285,7 +294,7 @@
 hg-buildregress-patho:
 	@for file in $(HGPATHO); do \
 	    echo "Remaking $${file}.fi"; \
-	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
+	    ./hg-$${file}-test 2>/dev/null | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
 		2>&1 || exit 1; \
 	done
 hg-regress-patho:
@@ -294,7 +303,7 @@
 	then \
 	    for test in $(HGPATHO); do \
 		if (echo "  $${test}" >&2; \
-		./hg-$${test}-test) | sed -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
+		./hg-$${test}-test 2>/dev/null) | sed -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
 		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
 		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
 	    done; \
@@ -321,25 +330,3 @@
 	    then \
 		(if { $(ECHO) -n "  $${test}.svn"; grep --text '^ ##' $${test}.svn || echo ' ## (no description)'; } >&2; \
 		$(REPOSURGEON) "read <$${test}.svn" "prefer git" "write -" >/tmp/regress$$$$ 2>&1; \
-		then diff --text -u $${test}.chk /tmp/regress$$$$ || exit 1; \
-		else echo "*** Nonzero return status on $${test}!"; exit 1; fi; \
-		if command -v git >/dev/null 2>&1 ; \
-		then \
-		    mkdir /tmp/reposurgeon$$$$ || exit 1; \
-		    (cd /tmp/reposurgeon$$$$ || exit 1; \
-			git init --quiet || exit 1; \
-			grep --text -v 'reposurgeon:' /tmp/regress$$$$ | git fast-import --quiet) \
-			    || exit 1; \
-		    rm -fr /tmp/reposurgeon$$$$\
-		else echo "    Skipped, git missing."; \
-		fi \
-		) || exit 1; \
-	    fi \
-	done
-	@rm -f /tmp/regress$$$$
-
-REFLOADS=references mergeinfo-with-split
-legacy-buildregress:
-	@for test in $(REFLOADS); \
-	do \
-	    echo "Remaking $${test}.map"; \

=== debian/changelog ===
reposurgeon (3.44-3) unstable; urgency=medium

  * Add build and runtime dependency on tzdata, which is no longer
    build-essential, and build chroots are not required to have it
    pre-installed, leading to FTBFS during a reposurgeon date test
    checking whether EST equals to -0500.  Thanks to Lucas Nussbaum
    for the report!  (Closes: #871163)
  * Fall back to /usr/bin/editor when $EDITOR is not set.
    This is to comply with Debian Policy §11.4, see
    https://www.debian.org/doc/debian-policy/#editors-and-pagers
    Thanks to Jakub Wilk for the report!  (Closes: #877011)
  * Remove now unneeded build dependency on libpython-dev

 -- Anthony Fok <foka@debian.org>  Tue, 17 Jul 2018 01:42:21 -0600

reposurgeon (3.44-2) unstable; urgency=medium

  * Switch from dh_python2 to dh_pypy properly.
    This fixes uninstallable pypy:any dependency in reposurgeon (3.44-1).
  * Change Architecture from "any" to "all"
  * Change nonexistent "svn" to "subversion" in Suggests field
  * Remove unneeded DEB_BUILD_ARCH and override_dh_auto_clean

 -- Anthony Fok <foka@debian.org>  Fri, 13 Jul 2018 07:27:18 -0600

reposurgeon (3.44-1) unstable; urgency=medium

  * New upstream release 3.44:
     - New 'setperm' command for patching file path permissions.
     - Abandon cyreposurgeon in favor of PyPy, which gives a better speedup.
     - Max working-set size has been reduced, enabling handling of larger repos.
     - New 'gitify' command for massaging comments into git conventional form.
     - The tag command now allows deleting all tags matching a regexp.
     - Fix crash when chaining '|', '&', '?' selection operators.
  * Abandon cyreposurgeon in favor of PyPy as per upstream (Closes: #879504)
  * Remove dependency on cython, and dependency on pypy and time,
  * Restore git build-dependency on alpha/ppc64/sparc64/x32
  * Restore missing README.md and friends from 3.44 release tarball
  * Prevent pylint from writing to /nonexistent home directory
    by adding "export PYLINTHOME := $(CURDIR)/.pylint.d" to debian/rules
  * Point Vcs-* URLs to salsa.debian.org
  * Rename debian-branch to debian/sid
  * Apply "cme fix dpkg" fixes to debian/control,
    bumping Standards-Version to 4.1.5, etc.
  * Use debhelper (>= 11)
  * Add debian/clean

 -- Anthony Fok <foka@debian.org>  Fri, 13 Jul 2018 04:33:48 -0600

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,39 @@
 Source: reposurgeon
+Maintainer: Anthony Fok <foka@debian.org>
 Section: vcs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
-Build-Depends: debhelper (>= 10), dh-python,
-               python, cython, libpython-dev, pkg-config, pylint,
-               xmlto, asciidoc-base,
-               cvs, git [!alpha !ppc64 !sparc64 !x32], mercurial, subversion
-Standards-Version: 4.0.0
+Build-Depends: debhelper (>= 11),
+               dh-python,
+               pypy,
+               python,
+               pkg-config,
+               pylint,
+               time,
+               tzdata,
+               xmlto,
+               asciidoc-base,
+               cvs,
+               git,
+               mercurial,
+               subversion
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
+Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
 Homepage: http://www.catb.org/esr/reposurgeon/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/reposurgeon.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/reposurgeon.git
 
 Package: reposurgeon
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
-Recommends: git, cvs-fast-export
-Suggests: bzr-fastimport, hg-fast-export, svn, darcs, fossil
+Architecture: all
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         ${pypy:Depends},
+         tzdata
+Recommends: git,
+            cvs-fast-export
+Suggests: bzr-fastimport,
+          hg-fast-export,
+          subversion,
+          darcs,
+          fossil
 Description: Tool for editing version-control repository history
  `reposurgeon` enables risky operations that version-control systems
  don't want to let you do, such as (a) editing past comments and metadata,
